Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 546746 - dev-qt/qtwebkit:4[exceptions] compiled with gcc-5 makes net-im/skype segfault
Summary: dev-qt/qtwebkit:4[exceptions] compiled with gcc-5 makes net-im/skype segfault
Status: RESOLVED OBSOLETE
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Qt Bug Alias
URL:
Whiteboard:
Keywords:
: 572370 (view as bug list)
Depends on:
Blocks: gcc-5
  Show dependency tree
 
Reported: 2015-04-16 08:55 UTC by Cănărău Constantin
Modified: 2017-11-21 18:51 UTC (History)
28 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
fix over qt4-build-multilib.eclass (qt4-build-multilib-sse.patch,668 bytes, patch)
2016-08-02 12:58 UTC, Denis Kaganovich
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Cănărău Constantin 2015-04-16 08:55:05 UTC
costel@gentoo ~ $ gdb skype
GNU gdb (Gentoo 7.9 vanilla) 7.9
Copyright (C) 2015 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-pc-linux-gnu".
Type "show configuration" for configuration details.
For bug reporting instructions, please see:
<http://bugs.gentoo.org/>.
Find the GDB manual and other documentation resources online at:
<http://www.gnu.org/software/gdb/documentation/>.
For help, type "help".
Type "apropos word" to search for commands related to "word"...
Reading symbols from skype...(no debugging symbols found)...done.
(gdb) run
Starting program: /opt/bin/skype 
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0xeb2feb40 (LWP 25940)]
[New Thread 0xe91fab40 (LWP 25944)]
[New Thread 0xe9afbb40 (LWP 25943)]
[New Thread 0xea2fcb40 (LWP 25942)]
[New Thread 0xeaafdb40 (LWP 25941)]
[New Thread 0xebaffb40 (LWP 25939)]
[New Thread 0xec6ffb40 (LWP 25938)]
[New Thread 0xed0ffb40 (LWP 25937)]
[New Thread 0xedaffb40 (LWP 25936)]
[New Thread 0xee4ffb40 (LWP 25935)]
[New Thread 0xeeefeb40 (LWP 25934)]
[New Thread 0xef6ffb40 (LWP 25933)]
[New Thread 0xf02feb40 (LWP 25932)]
[New Thread 0xf0affb40 (LWP 25931)]
[New Thread 0xf14ffb40 (LWP 25930)]
[New Thread 0xf1effb40 (LWP 25929)]
[New Thread 0xf28ffb40 (LWP 25928)]
[New Thread 0xf32ffb40 (LWP 25927)]
[New Thread 0xf3cffb40 (LWP 25926)]
[New Thread 0xf464cb40 (LWP 25925)]

Program received signal SIGSEGV, Segmentation fault.
0xf75a2ccf in ?? () from /usr/lib32/qt4/libQtWebKit.so.4


Reproducible: Always
Comment 1 Cănărău Constantin 2015-04-16 08:56:49 UTC
gentoo costel # emerge --info qtwebkit
Portage 2.2.18 (python 3.4.3-final-0, default/linux/amd64/13.0/desktop/gnome/systemd, gcc-5.1.0, glibc-2.21, 4.0.0-gentoo-costel x86_64)
=================================================================
                         System Settings
=================================================================
System uname: Linux-4.0.0-gentoo-costel-x86_64-Intel-R-_Core-TM-_i7_CPU_860_@_2.80GHz-with-gentoo-2.2
KiB Mem:     8169112 total,   4522488 free
KiB Swap:          0 total,         0 free
Timestamp of repository gentoo: Thu, 16 Apr 2015 05:45:02 +0000
sh bash 4.3_p33-r2
ld GNU ld (Gentoo 2.25 p1.0) 2.25
app-shells/bash:          4.3_p33-r2::gentoo
dev-java/java-config:     2.2.0::gentoo
dev-lang/perl:            5.20.2::gentoo
dev-lang/python:          2.7.9-r2::gentoo, 3.4.3::gentoo
dev-util/cmake:           3.2.1::gentoo
dev-util/pkgconfig:       0.28-r2::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.13.11::gentoo
sys-apps/sandbox:         2.6-r1::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.14.1::gentoo, 1.15::gentoo
sys-devel/binutils:       2.25::gentoo
sys-devel/gcc:            4.9.2::gentoo, 5.1.0::newer
sys-devel/gcc-config:     1.8::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.0::gentoo (virtual/os-headers)
sys-libs/glibc:           2.21::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://ftp.romnet.org/gentoo-portage
    priority: -1000

added
    location: /usr/portage/local/added
    masters: gentoo
    priority: 0

newer
    location: /usr/portage/local/newer
    masters: gentoo
    priority: 1

open
    location: /usr/portage/local/nou
    masters: gentoo
    priority: 100

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=native -w -fuse-linker-plugin -flto=4 -fipa-icf -fuse-ld=gold -floop-interchange -ftree-loop-distribution -floop-strip-mine -floop-block"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/lib64/libreoffice/program/sofficerc /usr/share/gnupg/qualified.txt /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -pipe -march=native -w -fuse-linker-plugin -flto=4 -fipa-icf -fuse-ld=gold -floop-interchange -ftree-loop-distribution -floop-strip-mine -floop-block"
DISTDIR="/mnt/linux/distfiles"
EMERGE_DEFAULT_OPTS="--jobs=3 --load-average=15 --keep-going --with-bdeps=y --complete-graph --quiet-build=n --autounmask-write"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs candy cgroup collision-protect config-protect-if-modified distlocks fail-clean fixlafiles ipc-sandbox merge-sync news nodoc noinfo parallel-install preserve-libs protect-owned sandbox sfperms strict unknown-features-filter unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://ftp.romnet.org/gentoo/ http://mirrors.xservers.ro/gentoo/ ftp://ftp.romnet.org/gentoo/ http://ftp.roedu.net/pub/mirrors/gentoo.org/ http://distfiles.gentoo.org/"
LANG="ro_RO.UTF-8"
LC_ALL="ro_RO.UTF-8"
LDFLAGS="-Wl,-O1,--sort-common,--hash-style=gnu,--as-needed,-z,now -O2 -pipe -march=native -w -fuse-linker-plugin -flto=4 -fipa-icf -fuse-ld=gold -floop-interchange -ftree-loop-distribution -floop-strip-mine -floop-block"
MAKEOPTS="-j8 --load-average=20"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--human-readable --delete-before --progress"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
USE="X a52 aac acl acpi alsa amd64 berkdb branding bzip2 cairo cdda cdr cli colord cracklib crypt cups cxx dbus dri dts dvd dvdr eds emboss encode evo exif fam ffmpeg firefox flac gdbm gif glamor gmp gnome gnome-keyring gnome-online-accounts gpm gstreamer gtk gtk3 iconv introspection ipv6 jpeg lcms ldap libnotify libsecret logrotate lua mad mmx mmxext mng modules mp3 mp4 mpeg multilib mysql nautilus ncurses networkmanager nls nptl ogg opengl openmp pam pango pch pcre pdf png policykit popcnt ppds pulseaudio python qt3support readline sdl server session socialweb spell sse sse2 sse3 sse4_1 sse4_2 ssl ssse3 startup-notification svg systemd tcpd threads tiff truetype udev udisks unicode upower usb vdpau vhosts vorbis wxwidgets x264 xcb xml xv xvid zlib" ABI_X86="64 32" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="efi-64 pc" INPUT_DEVICES="evdev keyboard mouse" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="ro en" NETBEANS_MODULES="apisupport extide php webcommon" NGINX_MODULES_HTTP="access auth_basic autoindex browser charset empty_gif fancyindex fastcgi geo gzip headers index limit_conn limit_req log map memcached naxsi pagespeed proxy redis referer rewrite scgi spdy ssi upstream_ip_hash userid uwsgi" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-6" PYTHON_SINGLE_TARGET="python3_4" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby20 ruby21" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.7 3.4"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS

=================================================================
                        Package Settings
=================================================================

dev-qt/qtwebkit-4.8.6-r1::gentoo was built with the following:
USE="exceptions jit pch (-aqua) -debug -gstreamer -icu" ABI_X86="32 64 -x32"
CFLAGS="-O2 -pipe -march=native -w -fno-lto"
CXXFLAGS="-O2 -pipe -march=native -w -fno-lto"
LDFLAGS="-Wl,-O1,--sort-common,--hash-style=gnu,--as-needed,-z,now -fno-lto"

As you can see above it segfault with safe, sane flags, too
Comment 2 octoploid 2015-04-17 18:36:32 UTC
Any chance you could build qtwebkit with debug info, to get a decent backtrace?
Comment 3 Cănărău Constantin 2015-04-18 09:04:32 UTC
Well, this is strange. With entire dev-qt/qt*:4 compiled with debug flag skype start and run successfully.

Reading symbols from skype...(no debugging symbols found)...done.
(gdb) run
Starting program: /opt/bin/skype 
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0xf09ffb40 (LWP 22197)]
[New Thread 0xe68ffb40 (LWP 22218)]
[New Thread 0xf13ffb40 (LWP 22196)]
[Thread 0xf13ffb40 (LWP 22196) exited]
[Thread 0xf09ffb40 (LWP 22197) exited]
[Thread 0xe68ffb40 (LWP 22218) exited]
[Inferior 1 (process 22187) exited normally]
(gdb) quit

But it still fail when -debug is used. I think that better to wait for final version of gcc to see what happed then.
Comment 4 Davide Pesavento gentoo-dev 2015-04-19 11:12:20 UTC
(In reply to Cănărău Constantin from comment #3)
> I think that better to wait for final
> version of gcc to see what happed then.

That, and qt 4.8.7 which should have better support for gcc-5.
Comment 5 Martin Väth 2015-05-02 06:01:17 UTC
Problem persists with gcc-5.1
Comment 6 octoploid 2015-05-02 06:57:13 UTC
(In reply to Martin Väth from comment #5)
> Problem persists with gcc-5.1

Two things come to mind.

1) https://sourceware.org/bugzilla/show_bug.cgi?id=16992
A nasty gold bug that was fixed only recently. 
Emerge binutils-9999 to get the fix.

2) https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65805
A bug in the new LRA rematerialization pass. This fix didn't make
it into gcc-5.1 release.
Comment 7 Cănărău Constantin 2015-05-03 06:52:07 UTC
> 2) https://gcc.gnu.org/bugzilla/show_bug.cgi?id=65805
> A bug in the new LRA rematerialization pass. This fix didn't make
> it into gcc-5.1 release.

binutils-9999 did not solve the problem. I tried with both gold and bfd.
Comment 8 Davide Pesavento gentoo-dev 2015-05-26 18:23:22 UTC
Please try with Qt 4.8.7
Comment 9 Cănărău Constantin 2015-05-27 11:07:01 UTC
Unfortunately, no changes. Skype still show "Aborted"
Comment 10 jospezial 2015-05-31 14:29:11 UTC
You could try with -O0 in CFLAGS.
This worked for wine.

have a look at
https://bugs.gentoo.org/show_bug.cgi?id=549768#c3
Comment 11 Davide Pesavento gentoo-dev 2015-05-31 15:53:19 UTC
Try with -fno-move-loop-invariants in your CXXFLAGS
Comment 12 Cănărău Constantin 2015-06-01 06:34:44 UTC
-fno-move-loop-invariants and/or -O0 make no difference. Skype still throw "Aborted".
Comment 13 pereira.alex 2015-06-01 07:34:03 UTC
I am also affected. ( using gcc 5.1 with qtwebkit-4.8.7-r1 )

Also, with -O0 and -fno-move-loop-invariants, the problem continues.
Comment 14 pereira.alex 2015-06-06 17:53:09 UTC
Seems the fellows in archlinux have manage to fix the problem by compiling qt4 with clang ( and skip the gcc 5.1 bug ) :

https://projects.archlinux.org/svntogit/community.git/commit/trunk?h=packages/lib32-qt4&id=d1ac61ee79ebbfbe314c6e5586e3b8635ec36354



I am in the process of trying this.
Comment 15 pereira.alex 2015-06-06 18:15:41 UTC
It worked.

Compiling qtwebkit:4 with clang, fixes the problem and skype works again.
Comment 16 Paul Healy 2015-07-16 09:00:41 UTC
If you came here (like me) looking for a solution to a skype abort on startup with gcc 4.8.4, then this might help:

The suggestion from here worked for me:
 
http://community.skype.com/t5/Linux/Skype-4-3-crash-on-ubuntu-14-04/td-p/3219892/page/2
 
sqlite3 ~/.Skype/[YOURUSER}/main.db
sqlite> DELETE FROM Messages WHERE type=68;
sqlite> .quit
 
** Note that this deletes file transfer history **
 
A -ggdb/nostrip build backtrace implicated: Qt::escape(QString const&)
Comment 17 Martin Väth 2015-07-18 15:13:27 UTC
Compiling qtwebkit with gcc-5.2 seems to solve the problem
Comment 18 Cănărău Constantin 2015-07-20 19:00:25 UTC
(In reply to Martin Väth from comment #17)
> Compiling qtwebkit with gcc-5.2 seems to solve the problem

Unfortunately, I can't confirm. With gcc-5.2.0 on qtwebkit:4 skype still throw "Aborted".
Comment 19 Konstantin (elxa) 2015-07-25 15:11:34 UTC
I recompiled all qt-4.8.7 packages with gcc-5.2.0 and skype segfaults. Trying clang next.

Program received signal SIGSEGV, Segmentation fault.
0xf757bfcf in WTF::HashTable<WTF::StringImpl*, WTF::StringImpl*, WTF::IdentityExtractor<WTF::StringImpl*>, WTF::StringHash, WTF::HashTraits<WTF::StringImpl*>, WTF::HashTraits<WTF::StringImpl*> >::rehash(int) () from /usr/lib32/qt4/libQtWebKit.so.4

(gdb) bt
#0  0xf757bfcf in WTF::HashTable<WTF::StringImpl*, WTF::StringImpl*, WTF::IdentityExtractor<WTF::StringImpl*>, WTF::StringHash, WTF::HashTraits<WTF::StringImpl*>, WTF::HashTraits<WTF::StringImpl*> >::rehash(int) () from /usr/lib32/qt4/libQtWebKit.so.4
#1  0xf757baee in WTF::AtomicString::add(unsigned short const*, unsigned int) () from /usr/lib32/qt4/libQtWebKit.so.4
#2  0xf6b66af8 in cssyyparse(void*) () from /usr/lib32/qt4/libQtWebKit.so.4
#3  0xf6cc00ee in WebCore::CSSParser::parseSheet(WebCore::CSSStyleSheet*, WTF::String const&, int, WTF::HashMap<WebCore::CSSStyleRule*, WTF::RefPtr<WebCore::CSSRuleSourceData>, WTF::PtrHash<WebCore::CSSStyleRule*>, WTF::HashTraits<WebCore::CSSStyleRule*>, WTF::HashTraits<WTF::RefPtr<WebCore::CSSRuleSourceData> > >*) () from /usr/lib32/qt4/libQtWebKit.so.4
#4  0xf6d09a0c in WebCore::CSSStyleSheet::parseStringAtLine(WTF::String const&, bool, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#5  0xf6d09a68 in WebCore::CSSStyleSheet::parseString(WTF::String const&, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#6  0xf6ce17d7 in WebCore::parseUASheet(WTF::String const&) () from /usr/lib32/qt4/libQtWebKit.so.4
#7  0xf6cf4540 in WebCore::loadFullDefaultStyle() () from /usr/lib32/qt4/libQtWebKit.so.4
#8  0xf6d07258 in WebCore::CSSStyleSelector::styleForElement(WebCore::Element*, WebCore::RenderStyle*, bool, bool, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#9  0xf6d33528 in WebCore::Document::styleForElementIgnoringPendingStylesheets(WebCore::Element*) () from /usr/lib32/qt4/libQtWebKit.so.4
#10 0xf6d505b1 in WebCore::Element::computedStyle(WebCore::PseudoId) () from /usr/lib32/qt4/libQtWebKit.so.4
#11 0xf6ea84ee in WebCore::HTMLTitleElement::textWithDirection() () from /usr/lib32/qt4/libQtWebKit.so.4
#12 0xf6ea862e in WebCore::HTMLTitleElement::childrenChanged(bool, WebCore::Node*, WebCore::Node*, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#13 0xf6d1d578 in WebCore::ContainerNode::parserAddChild(WTF::PassRefPtr<WebCore::Node>) () from /usr/lib32/qt4/libQtWebKit.so.4
#14 0xf7495149 in WebCore::HTMLConstructionSite::attachAtSite(WebCore::HTMLConstructionSite::AttachmentSite const&, WTF::PassRefPtr<WebCore::Node>) () from /usr/lib32/qt4/libQtWebKit.so.4
#15 0xf7496489 in WebCore::HTMLConstructionSite::insertTextNode(WTF::String const&) () from /usr/lib32/qt4/libQtWebKit.so.4
#16 0xf6ef2818 in WebCore::HTMLTreeBuilder::processCharacterBuffer(WebCore::HTMLTreeBuilder::ExternalCharacterTokenBuffer&) () from /usr/lib32/qt4/libQtWebKit.so.4
#17 0xf6ef3724 in WebCore::HTMLTreeBuilder::processCharacter(WebCore::AtomicHTMLToken&) () from /usr/lib32/qt4/libQtWebKit.so.4
#18 0xf6eef01f in WebCore::HTMLTreeBuilder::constructTreeFromAtomicToken(WebCore::AtomicHTMLToken&) () from /usr/lib32/qt4/libQtWebKit.so.4
#19 0xf6eef296 in WebCore::HTMLTreeBuilder::constructTreeFromToken(WebCore::HTMLToken&) () from /usr/lib32/qt4/libQtWebKit.so.4
#20 0xf6ed1968 in WebCore::HTMLDocumentParser::pumpTokenizer(WebCore::HTMLDocumentParser::SynchronousMode) () from /usr/lib32/qt4/libQtWebKit.so.4
#21 0xf6ed2bd9 in WebCore::HTMLDocumentParser::append(WebCore::SegmentedString const&) () from /usr/lib32/qt4/libQtWebKit.so.4
#22 0xf74359ec in WebCore::DecodedDataDocumentParser::appendBytes(WebCore::DocumentWriter*, char const*, int, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#23 0xf6f837bc in WebCore::DocumentWriter::addData(char const*, int, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#24 0xf6f7aad1 in WebCore::DocumentLoader::commitData(char const*, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#25 0xf6bcc60c in WebCore::FrameLoaderClientQt::committedLoad(WebCore::DocumentLoader*, char const*, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#26 0xf6f7b9bd in WebCore::DocumentLoader::commitLoad(char const*, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#27 0xf6fa6659 in WebCore::MainResourceLoader::addData(char const*, int, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#28 0xf6fb8f49 in WebCore::ResourceLoader::didReceiveData(char const*, int, long long, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#29 0xf6fa85f7 in WebCore::MainResourceLoader::didReceiveData(char const*, int, long long, bool) () from /usr/lib32/qt4/libQtWebKit.so.4
#30 0xf6fb8151 in WebCore::ResourceLoader::didReceiveData(WebCore::ResourceHandle*, char const*, int, int) () from /usr/lib32/qt4/libQtWebKit.so.4
#31 0xf71ed9f5 in WebCore::QNetworkReplyHandler::forwardData() () from /usr/lib32/qt4/libQtWebKit.so.4
#32 0xf71efdf2 in WebCore::QNetworkReplyHandlerCallQueue::flush() [clone .part.46] () from /usr/lib32/qt4/libQtWebKit.so.4
#33 0xf71f0ced in WebCore::QNetworkReplyWrapper::emitMetaDataChanged() () from /usr/lib32/qt4/libQtWebKit.so.4
#34 0xf71f0db0 in WebCore::QNetworkReplyWrapper::receiveSniffedMIMEType() () from /usr/lib32/qt4/libQtWebKit.so.4
#35 0xf71f11a3 in WebCore::QNetworkReplyWrapper::receiveMetaData() () from /usr/lib32/qt4/libQtWebKit.so.4
#36 0xf71f1509 in WebCore::QNetworkReplyWrapper::qt_static_metacall(QObject*, QMetaObject::Call, int, void**) [clone .part.47] () from /usr/lib32/qt4/libQtWebKit.so.4
#37 0xf563765e in QMetaObject::activate (sender=0x58ab0af0, m=0xf57cb840 <QIODevice::staticMetaObject>, local_signal_index=0, argv=0x0) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qobject.cpp:3567
#38 0xf5696e11 in QIODevice::readyRead (this=0x58ab0af0) at .moc/release-shared/moc_qiodevice.cpp:104
#39 0xf5696c9b in QIODevice::qt_static_metacall (_o=0x58ab0af0, _c=QMetaObject::InvokeMetaMethod, _id=0, _a=0x58ab1690) at .moc/release-shared/moc_qiodevice.cpp:53
#40 0xf56313aa in QMetaCallEvent::placeMetaCall (this=0x58ab16b0, object=0x58ab0af0) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qobject.cpp:524
#41 0xf5632697 in QObject::event (this=0x58ab0af0, e=0x58ab16b0) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qobject.cpp:1222
#42 0xf5a702fa in QApplicationPrivate::notify_helper(QObject*, QEvent*) () from /usr/lib32/qt4/libQtGui.so.4
#43 0xf5a77771 in QApplication::notify(QObject*, QEvent*) () from /usr/lib32/qt4/libQtGui.so.4
#44 0xf5618d62 in QCoreApplication::notifyInternal (this=0xffffcb7c, receiver=0x58ab0af0, event=0x58ab16b0) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.cpp:955
#45 0xf561cb0f in QCoreApplication::sendEvent (receiver=0x58ab0af0, event=0x58ab16b0) at ../../include/QtCore/../../../qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.h:231
#46 0xf5619db7 in QCoreApplicationPrivate::sendPostedEvents (receiver=0x0, event_type=0, data=0x58888410) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.cpp:1579
#47 0xf5619a33 in QCoreApplication::sendPostedEvents (receiver=0x0, event_type=0) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.cpp:1472
#48 0xf5655a63 in QCoreApplication::sendPostedEvents () at ../../include/QtCore/../../../qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.h:236
#49 0xf5654c30 in postEventSourceDispatch (s=0x588a3a88) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qeventdispatcher_glib.cpp:300
#50 0xf4ac15be in g_main_dispatch (context=0x588a39c8) at /var/tmp/portage/dev-libs/glib-2.44.1/work/glib-2.44.1/glib/gmain.c:3122
#51 0xf4ac23b8 in g_main_context_dispatch (context=0x588a39c8) at /var/tmp/portage/dev-libs/glib-2.44.1/work/glib-2.44.1/glib/gmain.c:3737
#52 0xf4ac25b3 in g_main_context_iterate (context=0x588a39c8, block=1, dispatch=1, self=0x588a4800) at /var/tmp/portage/dev-libs/glib-2.44.1/work/glib-2.44.1/glib/gmain.c:3808
#53 0xf4ac268c in g_main_context_iteration (context=0x588a39c8, may_block=1) at /var/tmp/portage/dev-libs/glib-2.44.1/work/glib-2.44.1/glib/gmain.c:3869
#54 0xf56554d1 in QEventDispatcherGlib::processEvents (this=0x588a3910, flags=...) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qeventdispatcher_glib.cpp:450
#55 0xf5b29fb6 in QGuiEventDispatcherGlib::processEvents(QFlags<QEventLoop::ProcessEventsFlag>) () from /usr/lib32/qt4/libQtGui.so.4
#56 0xf56165e6 in QEventLoop::processEvents (this=0xffffcad4, flags=...) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qeventloop.cpp:149
#57 0xf5616785 in QEventLoop::exec (this=0xffffcad4, flags=...) at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qeventloop.cpp:204
#58 0xf5619450 in QCoreApplication::exec () at /var/tmp/portage/dev-qt/qtcore-4.8.7/work/qt-everywhere-opensource-src-4.8.7/src/corelib/kernel/qcoreapplication.cpp:1227
#59 0xf5a6e7d4 in QApplication::exec() () from /usr/lib32/qt4/libQtGui.so.4
#60 0x5680387b in ?? ()
#61 0xf50f5587 in __libc_start_main (main=0x56801530, argc=1, argv=0xffffcea4, init=0x57c2d230 <jsimd_extxrgb_ycc_convert_sse2+2128512>, fini=0x57c2d220 <jsimd_extxrgb_ycc_convert_sse2+2128496>, rtld_fini=0xf7feb3a0 <_dl_fini>, stack_end=0xffffce9c) at libc-start.c:289
#62 0x567f6739 in ?? ()
Comment 20 Konstantin (elxa) 2015-07-25 15:54:13 UTC
Thx for the clang hint, I also recompiled dev-qt/qtwebkit:4 with clang and skype works again.
Comment 21 octoploid 2015-07-25 16:11:46 UTC
Looking at the backtrace: all the string parameters use the new C++ ABI.
I guess skype is compiled with an older compiler, so of course you'll get
segfaults.
Comment 22 Martin Väth 2015-07-25 17:44:48 UTC
(In reply to octoploid from comment #21)
> I guess skype is compiled with an older compiler, so of course you'll get
> segfaults.

If the obsolete string functions were hard-compiled in, this would give you linking errors, not a segfault.

Perhaps Cănărău and Konstantin did not yet compile their whole system with gcc-5.

I just can repeat that it works here on several systems (amd64 as well as x86).
The full systems were recompiled with gcc-5.1, only qtwebkit was compiled with gcc-5.2-
Comment 23 Cănărău Constantin 2015-07-25 18:23:56 UTC
No, the whole system was recompiled with gcc-5.2.0 from portage.
Comment 24 Jonathan Adamczewski 2015-07-26 08:16:09 UTC
This crash is not related to the std::string ABI changes.

StringHash::equal() in src/3rdparty/webkit/Source/JavaScriptCore/wtf/text/StringHash.h (which is at the top of the callstack when this crashes) has what appears to be a strict aliasing violation in the #else block. I've not looked closely at the codegen, but rebuilding after modifying to always use the "slow" path allowed me run skype.

Upon further investigation, this code is compiled with -fno-strict-aliasing, so I'm not sure that I've identified the right problem.


I'll post a patch at a later time (if no one else does) after I've verified the fix.
Comment 25 octoploid 2015-07-26 09:52:35 UTC
Interesting. It might be undefined behavior. 
You could try to build dev-qt/qtwebkit:4 with -fsanitize=undefined
and see if any runtime error pops up.
Comment 26 Ștefan Talpalaru 2015-08-01 00:39:57 UTC
(In reply to Paul Healy from comment #16)
> If you came here (like me) looking for a solution to a skype abort on
> startup with gcc 4.8.4, then this might help:
> 
> The suggestion from here worked for me:
>  
> http://community.skype.com/t5/Linux/Skype-4-3-crash-on-ubuntu-14-04/td-p/
> 3219892/page/2
>  
> sqlite3 ~/.Skype/[YOURUSER}/main.db
> sqlite> DELETE FROM Messages WHERE type=68;
> sqlite> .quit
>  
> ** Note that this deletes file transfer history **
>  
> A -ggdb/nostrip build backtrace implicated: Qt::escape(QString const&)

Thank you, this fixed a series of weird freezes on a non-experimental ~amd64.
Comment 27 Denis Sokolovsky 2015-11-03 10:23:07 UTC
I had similar problem, with skype aborted right after start (segfaulted under gdb). As some people reported that skype work for them I tried to play with USE flags and found that skype doesn't start if qtwebkit:4 compiled with "exceptions". Once I build qtwebkit:4 with "-exceptions" skype doesn't crash anymore.
Comment 28 Cănărău Constantin 2015-11-03 17:09:09 UTC
(In reply to Denis Sokolovsky from comment #27)
> I had similar problem, with skype aborted right after start (segfaulted
> under gdb). As some people reported that skype work for them I tried to play
> with USE flags and found that skype doesn't start if qtwebkit:4 compiled
> with "exceptions". Once I build qtwebkit:4 with "-exceptions" skype doesn't
> crash anymore.

I can confirm that. Now skype work witk qtwebkit:4 compiled with gcc-5.2
Thanks!
Comment 29 Martin Väth 2015-11-11 17:13:26 UTC
Just for the records: For me, skype[exceptions] works since gcc-5.2, so it might be that USE=-exceptions triggers something else (which on my machine works for other reasons).
Comment 30 Marc Arens 2015-12-16 22:27:25 UTC
After the upgrade gcc-5.3 i suddenly had the same segmentation fault in usr/lib32/qt4/libQtWebKit.so.4 and can confirm that recompiling qtwebkit:4 with -exceptions made skype work again.

Portage 2.2.26 (python 3.4.3-final-0, default/linux/amd64/13.0/desktop, gcc-5.3.0, glibc-2.22-r1, 4.3.0-gentoo x86_64)
=================================================================
System uname: Linux-4.3.0-gentoo-x86_64-Intel-R-_Core-TM-_i5-3570K_CPU_@_3.40GHz-with-gentoo-2.2
KiB Mem:    16307696 total,  10776768 free
KiB Swap:     524284 total,    524284 free
Timestamp of repository gentoo: Wed, 16 Dec 2015 20:15:02 +0000
sh bash 4.3_p42
ld GNU ld (Gentoo 2.25.1 p1.1) 2.25.1
app-shells/bash:          4.3_p42::gentoo
dev-java/java-config:     2.2.0::gentoo
dev-lang/perl:            5.22.0::gentoo
dev-lang/python:          2.7.11::gentoo, 3.4.3-r5::gentoo
dev-util/cmake:           3.4.1::gentoo
dev-util/pkgconfig:       0.29::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.19.1::gentoo
sys-apps/sandbox:         2.9::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.13.4::gentoo, 1.14.1::gentoo, 1.15::gentoo
sys-devel/binutils:       2.25.1-r1::gentoo
sys-devel/gcc:            4.9.3::gentoo, 5.3.0::gentoo
sys-devel/gcc-config:     1.8::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.3::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r1::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.de.gentoo.org/gentoo-portage                                                                
    priority: -1000                                                                                                     
                                                                                                                        
marens                                                                                                                  
    location: /home/marens/coding/git/overlay                                                                           
    masters: gentoo                                                                                                     
                                                                                                                        
ACCEPT_KEYWORDS="amd64 ~amd64"                                                                                          
ACCEPT_LICENSE="*"                                                                                                      
CBUILD="x86_64-pc-linux-gnu"                                                                                            
CFLAGS="-march=native -O2 -pipe"                                                                                        
CHOST="x86_64-pc-linux-gnu"                                                                                             
CONFIG_PROTECT="/etc /usr/share/config /usr/share/gnupg/qualified.txt /usr/share/maven-bin-3.3/conf /var/lib/hsqldb"    
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -O2 -pipe"                                                                                      
DISTDIR="/usr/portage/distfiles"                                                                                        
EMERGE_DEFAULT_OPTS="--jobs=8 --load-average=8 --keep-going=y"                                                          
FCFLAGS="-O2 -pipe"                                                                                                     
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch parallel-install preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"                              
FFLAGS="-O2 -pipe"                                                                                                      
GENTOO_MIRRORS="http://mirror.netcologne.de/gentoo/"                                                                    
LANG="en_US.utf8"                                                                                                       
LDFLAGS="-Wl,-O1 -Wl,--as-needed"                                                                                       
MAKEOPTS="-j9"                                                                                                          
PKGDIR="/usr/portage/packages"                                                                                          
PORTAGE_CONFIGROOT="/"                                                                                                  
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"                                                                                                    
PORTAGE_TMPDIR="/tmp"                                                                                                   
USE="X a52 aac acl acpi alsa amd64 berkdb bindist bluetooth branding bzip2 cairo cdda cdr cli cracklib crypt cups cxx dbus dri dts dvd dvdr emboss encode exif fam firefox flac fortran gdbm gif glamor gpm gtk iconv infinality ipv6 jpeg lcms ldap libnotify mad mmx mmxext mng modules mp3 mp4 mpeg multilib ncurses nls nptl ogg opengl openmp pam pango pcre pdf png ppds qt3support qt4 readline sdl seccomp session spell sse sse2 ssl startup-notification svg tcpd tiff truetype udev unicode upower usb vorbis wxwidgets x264 xattr xcb xml xv xvid zlib" ABI_X86="32 64" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias auth_digest dumpio lbmethod_byrequests proxy proxy_balancer proxy_http proxy_wstunnel slotmem_shm" APACHE2_MPMS="worker" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2 canon" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby21 ruby22" USERLAND="GNU" VIDEO_CARDS="intel i915 radeon" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.7"                                                                                                        
Unset:  CC, CPPFLAGS, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

[I] net-im/skype                                                                                                        
     Available versions:  (~)4.3.0.37-r5^msd {apulse pax_kernel plasma +pulseaudio selinux}                             
     Installed versions:  4.3.0.37-r5^msd(08:52:21 PM 12/16/2015)(apulse -pax_kernel -plasma -pulseaudio -selinux)      
     Homepage:            http://www.skype.com/                                                                         
     Description:         P2P Internet Telephony (VoiceIP) client
Comment 31 Fabio Coatti 2015-12-18 21:40:26 UTC
Same here, recompiling dev-qt/qtwebkit-4.8.7::gentoo with -exceptions fixes skype. before qtwebkit I recompiled all dynamic libraries used by qtwebkit and skype as well, without changes. Only removing exceptions solved the issue. I'm using gcc 5.3.0



Portage 2.2.26 (python 3.4.3-final-0, default/linux/amd64/13.0/desktop/plasma/systemd, gcc-5.3.0, glibc-2.22-r1, 4.3.3-cova x86_64)
=================================================================
System uname: Linux-4.3.3-cova-x86_64-Intel-R-_Core-TM-_i5-3427U_CPU_@_1.80GHz-with-gentoo-2.2
KiB Mem:     8091788 total,   2495580 free
KiB Swap:    8386556 total,   6826772 free
Timestamp of repository gentoo: Fri, 18 Dec 2015 15:00:01 +0000
sh bash 4.3_p42
ld ld di GNU (Gentoo 2.25.1 p1.1) 2.25.1
distcc[19464] (dcc_mkdir) ERROR: mkdir '/var/tmp/portage/.distcc//state' failed: No such file or directory [disabled]
app-shells/bash:          4.3_p42::gentoo
dev-java/java-config:     2.2.0::gentoo
dev-lang/perl:            5.22.0::gentoo
dev-lang/python:          2.7.11::gentoo, 3.3.5-r5::gentoo, 3.4.3-r5::gentoo, 3.5.1::gentoo
dev-util/cmake:           3.4.1::gentoo
dev-util/pkgconfig:       0.29::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.19.1::gentoo
sys-apps/sandbox:         2.9::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.11.6-r1::gentoo, 1.12.6::gentoo, 1.13.4::gentoo, 1.14.1::gentoo, 1.15-r1::gentoo
sys-devel/binutils:       2.25.1-r1::gentoo
sys-devel/gcc:            4.9.3::gentoo, 5.3.0::gentoo
sys-devel/gcc-config:     1.8::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.3::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r1::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://rsync.gentoo.org/gentoo-portage
    priority: -1000

hacking-gentoo
    location: /var/lib/layman/hacking-gentoo
    sync-type: laymansync
    sync-uri: rsync://rsync.mad-hacking.net/hacking-gentoo-overlay/
    masters: gentoo hacking-gentoo
    priority: 50

kde
    location: /var/lib/layman/kde
    sync-type: laymansync
    sync-uri: git://anongit.gentoo.org/proj/kde.git
    masters: gentoo
    priority: 50

local
    location: /usr/overlay
    masters: gentoo
    priority: 51

ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="* -@EULA"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -march=ivybridge -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -mno-sse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mno-lzcnt -mno-rtm -mno-hle -mrdrnd -mf16c -mfsgsbase -mno-rdseed -mno-prfchw -mno-adx -mfxsr -mxsave -mxsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -mno-clflushopt -mno-xsavec -mno-xsaves -mno-avx512dq -mno-avx512bw -mno-avx512vl -mno-avx512ifma -mno-avx512vbmi -mno-clwb -mno-pcommit -mno-mwaitx --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=3072 -mtune=ivybridge -fstack-protector-strong"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /etc/stunnel/stunnel.conf /usr/lib64/libreoffice/program/sofficerc /usr/share/config /usr/share/easy-rsa /usr/share/gnupg/qualified.txt /usr/share/themes/oxygen-gtk/gtk-2.0"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.6/ext-active/ /etc/php/cgi-php5.6/ext-active/ /etc/php/cli-php5.6/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -pipe -march=ivybridge -mmmx -mno-3dnow -msse -msse2 -msse3 -mssse3 -mno-sse4a -mcx16 -msahf -mno-movbe -maes -mno-sha -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mno-lzcnt -mno-rtm -mno-hle -mrdrnd -mf16c -mfsgsbase -mno-rdseed -mno-prfchw -mno-adx -mfxsr -mxsave -mxsaveopt -mno-avx512f -mno-avx512er -mno-avx512cd -mno-avx512pf -mno-prefetchwt1 -mno-clflushopt -mno-xsavec -mno-xsaves -mno-avx512dq -mno-avx512bw -mno-avx512vl -mno-avx512ifma -mno-avx512vbmi -mno-clwb -mno-pcommit -mno-mwaitx --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=3072 -mtune=ivybridge -fstack-protector-strong"
DISTDIR="/usr/portage/distfiles"
FCFLAGS="-O2 -pipe"
FEATURES="assume-digests binpkg-logs clean-logs config-protect-if-modified distlocks ebuild-locks fixlafiles merge-sync news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync xattr"
FFLAGS="-O2 -pipe"
GENTOO_MIRRORS="http://distfiles.gentoo.org"
LANG="it_IT.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
MAKEOPTS="-j4"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
USE="3dnow 3dnowext 3dnowprefetch X \ a52 aac aalib acl acpi aim alsa amd64 apng ares asf ati audio audiofile avahi bash-completion berkdb bidi bl branding bri bzip2 cairo caps ccdda cdda cdr cjk cli cracklib crypt cups curl cxx dba dbus declarative device-mapper dga divx divx4linux dparanoia dri dts dv dvb dvd dvdr dvdread eap-sim edl egl emboss encode ethereal evdev exif expat faad fam fame fbcon ffmpeg fftw firefox flac force-cgi-redirect fortran ftp gallium garmin gd gdbm gif gimp glamor gles2 gmedia gmp gnutls gphoto2 gpm gps gsm gtk h264 h323 iconv icq icu idn ifp ilbc imagemagick imap innodb ipod iproute2 ipv6 ithreads jabber java javascript joystick jpeg kde kipi kontact kvm lastfm lcms ldap libcaca libnotify libvirtd live lm_sensors lua lvm lxc lzma lzo mad maildir matroska mbox mdnsresponder-compat mhash mime mjpeg mmap mmx mmxext mng modules mozdevelop mozilla mp3 mp4 mpeg msn mtp multilib mysql ncurses network networkmanager new-hpcups nfsv4 njb nls nptl nptlonly nsplugin offensive ofx ogg oggvorbis ogm openal openexr opengl openmp oscar pam pango parted pcap pcre pdf phonon php plasma plotutils png policykit ppds pulseaudio qemu qml qt3support qt4 qt5 readline real rtc ruby samba sasl sdl seccomp semantic-desktop semantic-destkop session sha512 sip slang slp smartcard sndfile snmp sox speex spell srt sse sse2 ssh ssl ssse3 startup-notification svg symlink systemd tcltk tcpd telepathy theora threads tiff tk tremor truetype udev udisks unicode upower usb utempter v4l v4l2 vaapi vcd vde vhosts video videos vim-syntax virt-network virtualbox vorbis wav webkit widgets wifi wimax wmf wmp wps wxwidgets wxwindows x264 xanim xattr xcb xcomposite xface xft xine xinerama xml xosd xpm xscreensaver xsl xulrunner xv xvid zeroconf zlib zpm" ABI_X86="64 32" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="aes avx mmx mmxext popcnt sse sse2 sse3 sse4_1 sse4_2 ssse3" DRACUT_MODULES="btrfs crypt crypt-gpg crypt-loop lvm plymouth systemd" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" INPUT_DEVICES="evdev synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="it en" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="php5-5" PYTHON_SINGLE_TARGET="python3_4" PYTHON_TARGETS="python2_7 python3_4" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby20 ruby21 ruby22" USERLAND="GNU" VIDEO_CARDS="intel v4l" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.7 3.4"
Unset:  CC, CPPFLAGS, CTARGET, CXX, EMERGE_DEFAULT_OPTS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS
Comment 32 Peter Asplund 2015-12-19 15:37:22 UTC
Hi, I recently upgraded to GCC 5.3, changed in gcc-config and rebuilt everything using emerge -e @world.

I'm hitting this issue as well and I just wanted to say that removing my entries in the user database using sqlite, or doing "rm -rf ~/.Skype/, didn't help me at all. Still just "Aborted" when trying to start it.

I will try rebuilding using -exceptions.
Comment 33 Oleksandr Trotsenko 2015-12-21 06:29:17 UTC
Hello!

I have also faced the same issue and disabling the "exceptions" flag on dev-qt/qtwebkit has saved hours of my life.

Here's a bit more details.

I emerged skype and it would only run up to the terms agreements. Once I agree to the terms it would just crash.

# gcc-config -l
 [1] x86_64-pc-linux-gnu-5.3.0 *

$ gdb skype
GNU gdb (Gentoo 7.10.1 vanilla) 7.10.1
Copyright (C) 2015 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law.  Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-pc-linux-gnu".
Type "show configuration" for configuration details.
For bug reporting instructions, please see:
<https://bugs.gentoo.org/>.
Find the GDB manual and other documentation resources online at:
<http://www.gnu.org/software/gdb/documentation/>.
For help, type "help".
Type "apropos word" to search for commands related to "word"...
Reading symbols from skype...(no debugging symbols found)...done.
(gdb) run
Starting program: /opt/bin/skype 
[Thread debugging using libthread_db enabled]
Using host libthread_db library "/lib64/libthread_db.so.1".
[New Thread 0xf424eb40 (LWP 350)]
[New Thread 0xf38ffb40 (LWP 351)]
[New Thread 0xf2effb40 (LWP 352)]
[New Thread 0xf24ffb40 (LWP 353)]
[New Thread 0xf1affb40 (LWP 354)]
[New Thread 0xf10ffb40 (LWP 355)]
[New Thread 0xefefeb40 (LWP 356)]
[New Thread 0xf06ffb40 (LWP 357)]
[New Thread 0xef4ffb40 (LWP 358)]
[New Thread 0xeecfeb40 (LWP 359)]
[New Thread 0xee4fdb40 (LWP 360)]
[New Thread 0xedcfcb40 (LWP 361)]
[New Thread 0xed4fbb40 (LWP 362)]
[New Thread 0xeccfab40 (LWP 363)]
[New Thread 0xec4f9b40 (LWP 364)]
[New Thread 0xebcf8b40 (LWP 365)]
[New Thread 0xeb2ffb40 (LWP 366)]
[New Thread 0xeaafeb40 (LWP 367)]
[New Thread 0xea2fdb40 (LWP 368)]
[New Thread 0xe99fcb40 (LWP 369)]

Program received signal SIGSEGV, Segmentation fault.
0xf75955cf in ?? () from /usr/lib32/qt4/libQtWebKit.so.4

Then I added the following lines into my package.use:
dev-qt/qtwebkit:4 -exceptions

Recompiled: emerge --update --deep --newuse --with-bdeps=y @world (only the dev-qt/qtwebkit package had to be rebuilt in my case) and voila! - Skype starts and works good (so far so good, I am having my fingers crossed)

---------------

I am really happy I've found this bug, because it was my 1st Gentoo installation and I happened to be unlucky enough for Skype to happen the 1st software I tried emerging after getting Gnome up and running (so I was desperately splitting myself between debugging video drivers, studying my X.org log and sniffing journalctl)
Comment 34 Gary E. Miller 2016-01-15 22:05:08 UTC
(In reply to Oleksandr Trotsenko from comment #33)

> > Then I added the following lines into my package.use:
> dev-qt/qtwebkit:4 -exceptions
> 
> Recompiled: emerge --update --deep --newuse --with-bdeps=y @world (only the
> dev-qt/qtwebkit package had to be rebuilt in my case) and voila! - Skype
> starts and works good (so far so good, I am having my fingers crossed)

Works for me too.  Thanks!

From the day they were introduced into C++ I hated exceptions and they have been repeatedly troublesome.

> I am really happy I've found this bug, 

And I'm very happy you did too!  That is what I love about gentoo, if you are smart and motivated you can work around most any issue.
Comment 35 Amy Liffey gentoo-dev 2016-01-19 18:50:17 UTC
*** Bug 572370 has been marked as a duplicate of this bug. ***
Comment 36 Luis Lucas 2016-01-23 11:51:26 UTC
I had the same problem, and recompiling qtwebkit:4 with -exceptions solved the problem.
What is the purpose of this use flag?
Should this workaround be made permanent?
Comment 37 zlg (RETIRED) gentoo-dev 2016-02-01 01:52:07 UTC
I can also confirm qtwebkit:4 -exceptions fixes the problem.

I've added a note regarding it (and the many other USE flags needed) in the wiki [1].

[1]: https://wiki.gentoo.org/wiki/Skype
Comment 38 Amy Liffey gentoo-dev 2016-02-01 10:57:29 UTC
author	Amy Winston <amynka@gentoo.org>	2016-02-01 10:55:13 (GMT)
committer	Amy Winston <amynka@gentoo.org>	2016-02-01 10:55:13 (GMT)
commit	d24265bc817901f3e90156928db582abad7ef29a

net-im/skype: qtwebkit[-exceptions] bug #546746
Comment 39 Gleb 2016-02-01 16:41:37 UTC
Why this fix was commited without checking compatibility with other ebuilds? This fix breaks goldendict which is stable, while skype is not.

This is the ebuild for goldendict and it requires qtwebkit to be build with exceptions flag: https://gitweb.gentoo.org/repo/gentoo.git/tree/app-text/goldendict/goldendict-1.0.1.ebuild
Comment 40 Amy Liffey gentoo-dev 2016-02-01 17:10:40 UTC
(In reply to Gleb from comment #39)
> Why this fix was commited without checking compatibility with other ebuilds?
> This fix breaks goldendict which is stable, while skype is not.
> 
> This is the ebuild for goldendict and it requires qtwebkit to be build with
> exceptions flag:
> https://gitweb.gentoo.org/repo/gentoo.git/tree/app-text/goldendict/
> goldendict-1.0.1.ebuild

Well it's upstream bug. So there is not really easy way to repair it. If skype is working for you just mask the new revision.

I will try to find out better way but I am afraid it don't exists.
Comment 41 Martin Väth 2016-02-01 17:26:14 UTC
In reply to Gleb from comment #39)
> Why this fix was commited without checking compatibility with other ebuilds?

It happens for several ebuilds that they cannot be installed simultaneously because of blocking dependencies. This cannot be avoided and must be accepted as long as it does not produce unresolvable dependency cycles or collides with packages from the base system (or their non-optional dependencies).
Blame upstream for making the corresponding packages incompatible!

> This fix breaks goldendict which is stable, while skype is not.

This is completely irrelevant for colliding dependencies. In particular, it is not a reason to let one of the packages claim dependencies with which it does not work. Only for cyclic dependencies one would have to apply dirty hacks if necessary to avoid the problem (like forcing to install two qtweb versions and changing paths during runtime - which can lead to other problems).
Comment 42 Davide Pesavento gentoo-dev 2016-02-01 17:49:43 UTC
The question is: does goldendict really need exceptions enabled? My guess is that it doesn't.
Comment 43 Matteo Modesti 2016-02-02 18:46:59 UTC
Why are you making everyone disable the "exceptions" flag instead of just those who use >=sys-devel/gcc-5 ? You even deleted the -r5 ebuild!
GCC 4.9 is stable while 5.* are NOT! I have absolutely no problem whatsoever with Skype using 4.9.

The right way is to introduce and/or logic to dependencies, or to use the stable GCC version, or AT LEAST to leave the -r5 ebuild for us to use. It sure ISN'T the right way to delete the -r5 ebuild after wrongly making everyone disable a USE flag in -r6 !
Comment 44 Amy Liffey gentoo-dev 2016-02-03 06:49:05 UTC
author	Amy Winston <amynka@gentoo.org>	2016-02-02 22:41:42 (GMT)
committer	Amy Winston <amynka@gentoo.org>	2016-02-02 22:41:42 (GMT)
commit	08c27e4668323f40f037392913b18f2b98f71d68 

net-im/skype: Add old revision bug #546746.
Comment 45 Denis Sokolovsky 2016-02-03 15:27:56 UTC
Can't you add conditional depend? Something like

[[ $(gcc-major-version) -ge 5 ]] && RDEPEND="${RDEPEND} dev-qt/qtwebkit:4[-exceptions]"

It still require notice, because user can have qtwebkit compiled with gcc-5, while current compiler is gcc-4.

Also, IIRC, somewhere in documentation was statement that correct way is to enable ~keyword globally. Per package keyword accepting can lead to problems. So it's logical to make stable skype with depend on "dev-qt/qtwebkit:4[abi_x86_32]" (to match with stable gcc:4.9) and keyworded skype with depend on "dev-qt/qtwebkit:4[abi_x86_32,-exceptions]" (to match with keyworded gcc:5).
Comment 46 Martin Väth 2016-02-03 17:14:49 UTC
(In reply to Denis Sokolovsky from comment #45)
> Can't you add conditional depend?

Such things are not possible: Dependencies always have to be static.

What might be possible is a test in some phase (e.g. pkg_setup) and to die if the compiler does not _appear_ to match. But this would be a bad idea either, because it will break horribly for user of binary packages, and actually does not prove which gcc version was used to compile qtwebkit.

Best thing would be really to let the dependency to -exception unconditionally, as it was correct before the whining here started:
All skype users will have to set this eventually, anyway, and skype is unstable, hence meant for unstable users.
Just that currently it works by chance also with +exceptions for some users/compilers, is not an excuse to not set the safe dependency.
Comment 47 Denis Sokolovsky 2016-02-04 18:22:13 UTC
(In reply to Martin Väth from comment #46)
> (In reply to Denis Sokolovsky from comment #45)
> > Can't you add conditional depend?
> 
> Such things are not possible: Dependencies always have to be static.

Allow me to disagree here. When ebuild is parsed everything in global scope are evaluated. Like in shell scripts. This allow to make some checks and mangle variables (and not only variables) accordingly. You certainly can't change *DEPENDS in build steps like pkg_setup/src_prepare/etc. This is simply meaningless. But you can change them at source time. In current portage tree you can found a lot of such examples (app-misc/lcdproc, media-libs/mesa, etc).
Comment 48 Martin Väth 2016-02-05 11:19:40 UTC
(In reply to Denis Sokolovsky from comment #47)
>
> > Such things are not possible: Dependencies always have to be static.
> 
> Allow me to disagree here. When ebuild is parsed [...]

This is only the technical aspect how the static {R,P,}DEPEND strings are obtained. This does not change the fact that they must be static, i.e. identical on all machines which use the gentoo repository.

Note that the static strings are stored in the rsync tree in the metadata/* subdirectory.

> In current portage tree you can found a lot of such examples

All these "examples" are static. Otherwise, these would be serious bugs.
Of course, for obtaining the static strings you can use certain other static data like the ebuild version or an eclass, but you must not use anything which is not universal on all machines.
Comment 49 Denis Sokolovsky 2016-02-05 17:29:21 UTC
(In reply to Martin Väth from comment #48)
Gentoo dev manual doesn't say anything about "static"-ness of any variable. Metadata used only in searches, AFAIK. So, it theory, dependency mangling is allowed.

From other side, I prefer second option, with stable and keyworded ebuilds, as it seems much more logical solution here.

From yet other side, it's not me who make decisions and changes in ebuild, so future discussion is pointless.
Comment 50 Martin Väth 2016-02-05 22:27:46 UTC
(In reply to Denis Sokolovsky from comment #49)
> Gentoo dev manual doesn't say anything about "static"-ness of any variable.

Perhaps it should be made clearer. It seems, it is currently only implicit here:

pms, Section 11.3: "When an ebuild is being sourced for metadata querying (that is to say, when none of the src_ or pkg_ functions are to be called), no external command may be executed."

Although it is not stated explicitly, it should be clear that testing the existence of files or a callback to the package mangler via has_version have to be considered as an external command in this context. pms goes even further and forbids even explicitly in_iuse in global scope.

> Metadata used only in searches, AFAIK.

No. It is the information which portage uses when calculating dependencies. Otherwise portage would be horribly slow. Calculating this metadata takes hours. You can see this by removing that directory and calling egencache --repo=gentoo --update to regenerate it (only updating it - without removing - is rather fast, because the metadata contains checksums to see what needs to be regenerated).

If you do not generate the metadata with egencache, portage generates the cache tacitly in /var/cache/edb/dep (by using the same checksum mechanism).

Now if the data wouldn't be static, this checksum mechanism would not be sufficient, and the metadata cache would have to regenerated with practically every call of portage. This would mean a practically unusable slow portage.
Comment 51 Cănărău Constantin 2016-02-06 10:32:01 UTC
Would it be possible to mark skype 4.3.0.37-r5 as stable so it does not need dev-qt/qtwebkit:4[-exceptions] for now because gcc-5 is not stable and leave -r6 as unstable ? 

Yes, skype is closed source and there are good reasons to be keyworded as ~x86 ~amd64 and the above solution do not cover all cases, but, in the end, AFAIK skype is not pulled as dependecy at all or not very often.

Anyway, even the current situation do not require other that to mask =net-im/skype-4.3.0.37-r6 for those who need dev-qt/qtwebkit:4[exceptions], which seems to be quite trivial. If we are talking about things done right (yes, as it should)... qt4 will not receive any future updates, skype for linux are a bit obsolete, a qt5 version of skype is desired, closed source package and so on...
It seems to me like a perfect condition for a compromise given current circumstances.

What do you think ?
Comment 52 Constantin Baranov 2016-02-06 11:22:07 UTC
I'm under impression that the real problem sits somewhere between qtwebkit and gcc. Either gcc simply generates bad code or qtwebkit code is dirty enough to fail sometimes, and skype is lucky to hit the problem indirectly. If I'm right, restricting dependencies of skype is wrong workaround. At most skype ebuild could issue a warning about potential problem and tell how to avoiding it. Qt ebuild should check in pkg_pretend if gcc profile is 5+ and USE=exceptions, then scream loud or fail with an option to explicitly override by user.
Comment 53 Denis Sokolovsky 2016-02-07 15:13:35 UTC
(In reply to Martin Väth from comment #50)
Haven't seen this "no external command may be executed" part. And because gcc_major_version involve command execution it is became illegal.

(In reply to Constantin Baranov from comment #52)
This is not necessary true. gcc-5 have some ABI incompatibilities in generated code, comparing to gcc-4. So, part, which use exceptions, can be ABI incompatible (this include data size changes, not only function name changes). The solution can be as easy as compile skype with gcc-5, but we can't check, because skype has closed sources.
Comment 54 Denis Kaganovich 2016-02-13 14:23:14 UTC
Hmm... why I don't have this problem?

I use some own old patches for gcc (even not sure about it requirement for v5). Try add -mstackrealign or disable sse* for 32bit abi to similar behaviour (or just AMD CPU with "misalignsse" feature).

To be precise, I also use next code in dev-qt/* bashrc:
https://raw.githubusercontent.com/mahatma-kaganovich/raw/master/app-portage/ppatch/files/extensions/dev-qt/qt.bashrc

Portage 2.2.27 (python 2.7.11-final-0, !/usr/ppatch/profiles/native, gcc-5.3.0, glibc-2.22-r1, 4.4.0 x86_64)
=================================================================
System uname: Linux-4.4.0-x86_64-Intel-R-_Celeron-R-_CPU_G1840_@_2.80GHz-with-gentoo-2.2
KiB Mem:     3960580 total,    293756 free
KiB Swap:   19535868 total,  19166128 free
Timestamp of repository gentoo: Sat, 13 Feb 2016 00:00:01 +0000
sh bash 4.3_p42-r1
ld GNU ld (Gentoo 2.25.1 p1.1) 2.25.1
distcc 3.2rc1 x86_64-pc-linux-gnu [disabled]
ccache version 3.2.4 [disabled]
app-shells/bash:          4.3_p42-r1::gentoo
dev-lang/perl:            5.22.1::gentoo
dev-lang/python:          2.7.11-r2::gentoo, 3.4.3-r7::gentoo, 3.5.1-r2::gentoo
dev-util/ccache:          3.2.4::gentoo
dev-util/cmake:           3.4.3::gentoo
dev-util/pkgconfig:       0.29::gentoo
sys-apps/baselayout:      2.2::gentoo
sys-apps/openrc:          0.20.4::gentoo
sys-apps/sandbox:         2.10-r1::gentoo
sys-devel/autoconf:       2.13::gentoo, 2.69-r1::gentoo
sys-devel/automake:       1.9.6-r4::gentoo, 1.11.6-r2::gentoo, 1.13.4-r1::gentoo, 1.14.1-r1::gentoo, 1.15-r1::gentoo
sys-devel/binutils:       2.25.1-r1::gentoo
sys-devel/gcc:            5.3.0::gentoo
sys-devel/gcc-config:     1.8::gentoo
sys-devel/libtool:        2.4.6-r1::gentoo
sys-devel/make:           4.1-r1::gentoo
sys-kernel/linux-headers: 4.4::gentoo (virtual/os-headers)
sys-libs/glibc:           2.22-r1::gentoo
Repositories:

gentoo
    location: /usr/portage
    sync-type: rsync
    sync-uri: rsync://10.200.200.206/gentoo-portage/
    priority: -1000
    eclass-overrides: raw
    sync-rsync-extra-opts: --exclude=/metadata/cache --whole-file --no-compress --inplace --compress-level=1 -q -c
    sync-rsync-vcs-ignore: true

raw
    location: /var/lib/layman/raw
    sync-type: git
    sync-uri: https://github.com/mahatma-kaganovich/raw.git
    masters: gentoo
    eclass-overrides: raw

x11
    location: /var/lib/layman/x11
    masters: gentoo
    priority: 0
    eclass-overrides: raw

local
    location: /usr/local/portage
    masters: gentoo
    priority: 1
    eclass-overrides: raw

Installed sets: @system, @utils
ACCEPT_KEYWORDS="amd64 x86 ~amd64 ~x86"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -O3 -pipe -fno-ident -fomit-frame-pointer -fexcess-precision=fast -Ofast -ffast-math -ftree-vectorize -fivopts -fbranch-target-load-optimize -fmodulo-sched -fmodulo-sched-allow-regmoves -freschedule-modulo-scheduled-loops -fpeel-loops -funroll-loops -ftree-loop-distribution -ftree-loop-im -ftree-loop-ivcanon -fvariable-expansion-in-unroller -ftracer -floop-block -floop-strip-mine -floop-interchange -mtune=native -march=native -mxsave -mxsaveopt -malign-data=cacheline -momit-leaf-frame-pointer -mtls-dialect=gnu2 -minline-stringops-dynamically -maccumulate-outgoing-args -mfpmath=both -w -Wa,--reduce-memory-overheads"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/gnupg/qualified.txt /var/bind"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CPPFLAGS="-pipe"
CXXFLAGS="-O2 -O3 -pipe -fno-ident -fomit-frame-pointer -fexcess-precision=fast -Ofast -ffast-math -ftree-vectorize -fivopts -fbranch-target-load-optimize -fmodulo-sched -fmodulo-sched-allow-regmoves -freschedule-modulo-scheduled-loops -fpeel-loops -funroll-loops -ftree-loop-distribution -ftree-loop-im -ftree-loop-ivcanon -fvariable-expansion-in-unroller -ftracer -floop-block -floop-strip-mine -floop-interchange -mtune=native -march=native -mxsave -mxsaveopt -malign-data=cacheline -momit-leaf-frame-pointer -mtls-dialect=gnu2 -minline-stringops-dynamically -maccumulate-outgoing-args -mfpmath=both -fvisibility-inlines-hidden -w -Wa,--reduce-memory-overheads -fno-ipa-pta"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--nospinner --autounmask-keep-masks --backtrack=5"
FCFLAGS="-O2 -O3 -pipe -fno-ident -fomit-frame-pointer -fexcess-precision=fast -Ofast -ffast-math -ftree-vectorize -fivopts -fbranch-target-load-optimize -fmodulo-sched -fmodulo-sched-allow-regmoves -freschedule-modulo-scheduled-loops -fpeel-loops -funroll-loops -ftree-loop-distribution -ftree-loop-im -ftree-loop-ivcanon -fvariable-expansion-in-unroller -ftracer -floop-block -floop-strip-mine -floop-interchange -mtune=native -march=native -mxsave -mxsaveopt -malign-data=cacheline -momit-leaf-frame-pointer -mtls-dialect=gnu2 -minline-stringops-dynamically -maccumulate-outgoing-args -mfpmath=both -w -Wa,--reduce-memory-overheads"
FEATURES="assume-digests binpkg-logs config-protect-if-modified distlocks fixlafiles merge-sync news parallel-fetch parallel-install preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -O3 -pipe -fno-ident -fomit-frame-pointer -fexcess-precision=fast -Ofast -ffast-math -ftree-vectorize -fivopts -fbranch-target-load-optimize -fmodulo-sched -fmodulo-sched-allow-regmoves -freschedule-modulo-scheduled-loops -fpeel-loops -funroll-loops -ftree-loop-distribution -ftree-loop-im -ftree-loop-ivcanon -fvariable-expansion-in-unroller -ftracer -floop-block -floop-strip-mine -floop-interchange -mtune=native -march=native -mxsave -mxsaveopt -malign-data=cacheline -momit-leaf-frame-pointer -mtls-dialect=gnu2 -minline-stringops-dynamically -maccumulate-outgoing-args -mfpmath=both -w -Wa,--reduce-memory-overheads"
GENTOO_MIRRORS="http://www.bspu.by/gentoo-portage/ ftp://ftp.byfly.by/pub/gentoo-distfiles/ http://distfiles.gentoo.org"
LANG="ru_RU.utf8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,--hash-style=gnu -Wl,--sort-common -Wl,--sort-section=alignment -Wl,--no-keep-memory -Wl,--reduce-memory-overheads"
MAKEOPTS="-j2 -s"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--exclude=/metadata/cache --whole-file --no-compress --inplace --compress-level=1 -q -c"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --omit-dir-times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages --exclude=/.git"
PORTAGE_TMPDIR="/var/tmp"
USE="3dnow 3dnowext 64-bit-bfd X _vtk a52 aac aacplus aalib acl acpi aio alsa amd64 amr animgif apng apulse archive audio autotrace awt bluray branding bs2b build-kernel bzip2 cairo cdda cddb chardet clamav clamd classic cli client client-libs corefonts cracklib crypt cue cups custom-arch custom-cflags cxx dane desktop devil dga dirac djvu dmx dri drm dts dv dvd dvdnav dvdr egl embed-hardware emf encode epoll evdev exif experimental extensions external-firmware extras faac faad ffmpeg fftw firmware fits flac flash fontconfig fortran fpx freerdp frei0r ftp fuse gbm gdbm gif gles1 gles2 gltf glut gmp gnutls gpm graphviz gsm gtk gtk2 gts gudev gui harfbuzz http iconv icu idn imagemagick imlib infinality ipv6 ithreads jabber jpeg jpeg2k kate kernel-alsa kernel-drm kms kpoll lame lasi lcms lensfun libass libatomic libev libevent libkms libmpeg2 libnet libsamplerate libsoxr libtiger libv4l lirc live logrotate lto lz4 lzma lzo mad mathml matroska mbox minimal2 minizip mjpeg mmap mmx mmxext mng mp3 mpeg mtp multicall multilib musepack nas natspec ncurses nls nptl nsplugin ntp numa nut ogg omxil openal opencl opencv openexr opengl openipmi openmax openmp openssl opus pango pcre pcre16 pcre32 pdf perl pgo pkcs11 plotutils png pnm poll popcnt postproc postscript pptx projectm pvr python2 q16 q32 q64 q8 quicktime quvi radio radosgw raw rdp readline rfc3779 rle rpc rtc rtmp rtp rtsp samba schroedinger sctp seccomp session sftp shout silc slang smp snappy sndfile sound speex srtp sse sse2 sse3 sse4a ssh ssl subversion svg t1lib taglib tbb tcmalloc tga theora threads tiff tint2 tmem tools truetype twolame uchardet udev umfpack unicode update-boot upnp urandom usb utils v4l vaapi vcd vcdx vdpau video vnc vorbis vpx vte wavpack wayland webp webstart winbind wma-fixed wmf wxwidgets x264 x265 xa xanim xattr xcb xdg xft xinerama xkb xlib-xcb xpm xrandr xv xvid xvmc xwayland xz yuv4mpeg zlib ztv" ABI_X86="32 64" ALSA_CARDS="hda-intel" APACHE2_MODULES="authn_core authz_core socache_shmcb unixd actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias auth_digest proxy_http proxy access_compat access_compat auth_digest" APACHE2_MPMS="itk" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump author" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" CPU_FLAGS_X86="mmx mmxext sse sse2 smp sse mmxext sse3 64-bit-bfd fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush dts acpi mmx fxsr sse2 ss ht tm pbe syscall nx pdpe1gb rdtscp constant_tsc arch_perfmon pebs bts rep_good nopl xtopology nonstop_tsc aperfmperf eagerfpu pclmulqdq dtes64 monitor ds_cpl vmx est tm2 ssse3 sdbg cx16 xtpr pdcm pcid sse4_1 sse4_2 movbe popcnt tsc_deadline_timer xsave rdrand lahf_lm abm arat epb pln pts dtherm tpr_shadow vnmi flexpriority ept vpid fsgsbase tsc_adjust erms invpcid xsaveopt mmx sse mmxext sse2 mmxext 3dnowext mmxext 3dnow sse3 popcnt sse4a fpu vme de pse tsc msr pae mce cx8 apic sep mtrr pge mca cmov pat pse36 clflush fxsr ht syscall nx fxsr_opt pdpe1gb rdtscp lm constant_tsc rep_good nopl nonstop_tsc extd_apicid monitor cx16 lahf_lm cmp_legacy svm extapic cr8_legacy abm misalignsse 3dnowprefetch osvw ibs skinit wdt hw_pstate npt lbrv svm_lock nrip_save vmmcall" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ublox ubx" GRUB_PLATFORMS="pc" INPUT_DEVICES="evdev synaptics" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="ru ru_RU be be_BY en" LIRC_DEVICES="userspace" OFFICE_IMPLEMENTATION="libreoffice" PHP_TARGETS="PHP5-4 php5-5" PYTHON_SINGLE_TARGET="python2_7" PYTHON_TARGETS="python2_7 python3_4" RUBY_TARGETS="ruby20 ruby21" USERLAND="GNU" VIDEO_CARDS="nouveau intel ilo i965 i915" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
Unset:  CC, CTARGET, CXX, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, USE_PYTHON
Comment 55 Denis Kaganovich 2016-02-13 17:49:59 UTC
PS To my config: -Ofast -ffast-math filtered for qtwebkit in other place.
Comment 56 Pavel Kozlov 2016-02-17 21:31:32 UTC
I need to build goldendict, which requires qtwebkit with +exceptions. It means I can't have both goldendict and skype installed on my machine at the same time. I use gcc-4.9.3, it's stable (I have no reason to use gcc-5.3.0).

I just want to have skype and goldendict installed at the same time. What should I do?

Why does skype-4.3.0.37-r6 requires qtwebkit with -exceptions? I think people who really need skype with gcc-5 can turn it off manually.
Comment 57 Amy Liffey gentoo-dev 2016-02-17 22:16:42 UTC
(In reply to Pavel Kozlov from comment #56)
> I need to build goldendict, which requires qtwebkit with +exceptions. It
> means I can't have both goldendict and skype installed on my machine at the
> same time. I use gcc-4.9.3, it's stable (I have no reason to use gcc-5.3.0).
> 
> I just want to have skype and goldendict installed at the same time. What
> should I do?
> 
> Why does skype-4.3.0.37-r6 requires qtwebkit with -exceptions? I think
> people who really need skype with gcc-5 can turn it off manually.

You can install old revision.

Amy
Comment 58 Gleb 2016-02-19 12:56:05 UTC
For thoose, who would like to have installed Skype and GoldenDict at the same time with GCC5, you could try GoldenDict with Qt5 support from git. I didn't try to compile it with gcc5, but it doesn't require any Qt4 library and at the same time you can have Skype with Qt4 to be installed. GoldenDict from git works without any issues. This verison is 1.5 RC and it's in development since 2013 (yes, sadly, still no final release). Here's my ebuild for GoldenDict in another bugreport: https://bugs.gentoo.org/show_bug.cgi?id=574464
Comment 59 Denis Kaganovich 2016-08-02 12:58:46 UTC
Created attachment 442292 [details, diff]
fix over qt4-build-multilib.eclass

I see no progress... but it can be easy solved.

This patch adding "-mstackrealign" ONLY on multilib x86_32 + x86_64 Qt build (pure x86 must use other solution or remove "&& use_if_iuse abi_x86_64 " if sure, but this can provide worse code, need only on SSE machines and violate SysV ABI, so not popular). It not affect 64-bit ABI.

I don't verify this patch directly, but all my systems applying own patch to GCC, making "-mstackrealign" automatic and ready to all optimizations (https://github.com/mahatma-kaganovich/raw/tree/master/app-portage/ppatch/files/extensions/gcc/compile/sse-stackrealign). Also in resent GCC's it is default for Windows.
Comment 60 Andreas Sturmlechner gentoo-dev 2017-11-21 18:51:26 UTC
net-im/skype is no longer in tree.